// 1,selectΥ롼פݲƤ롢ΤȤgdkεǽȤäơ
// GUI Υ롼פ򤷤Ƥ롣
// 2,event dispatch for GtkWidget and Xlib Window.
// 3,XIM̿γΩԤ

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include "heke.h"
#include "gtkdispatch.h"
#include "xdispatch.h"

#include <gtk/gtk.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <unistd.h>
#include <stdio.h>
#include <map>

#ifndef GETHOSTNAME_DECLARED
extern "C" int gethostname ();
#endif

extern int g_serv_port;

Atom xim_servers;
Atom server_heke;
Atom locales;
Atom transport;

// selection뤿Υɥ
Window wnd;
//ѤΥǥץ쥤³
Display *g_dpy;

struct widget_watch_struct{
    GtkWidget *w;
    WidgetIf *i;
    int mask;
};

struct fd_watch_struct{
    int read_tag,write_tag;
    int mask;
    void (*fn)(int,int);
};

static map<int,fd_watch_struct> fd_watch_stat;
static map<unsigned int,WindowIf *> window_watch_stat;
static map<GtkWidget *,widget_watch_struct *>widget_watch_stat;

// fd watchʬ
static void fd_event_handler(gpointer p,gint fd,GdkInputCondition c)
{
    // GdkInputConditionenumʤΤ or Ƥ롣
    map<int,fd_watch_struct>::iterator i;
    int ev;
    i = fd_watch_stat.find(fd);
    if ( i == fd_watch_stat.end()){
        // danger ..
        printf("Unknown fd %d event.\n",fd);
        return ;
    }
    ev = 0;
    if ( c & GDK_INPUT_READ ){
        (*i).second.fn(fd,READ_OK);
    }
    if ( c & GDK_INPUT_WRITE ){
        (*i).second.fn(fd,WRITE_OK);
    }
}

static void remove_current_watch(int fd)
{
    map<int,fd_watch_struct>::iterator i;
    i = fd_watch_stat.find(fd);
    if ( i == fd_watch_stat.end() ){
        return ;
    }
    if ( (*i).second.mask & READ_OK){
        gdk_input_remove((*i).second.read_tag);
    }
    if ( (*i).second.mask & WRITE_OK){
        gdk_input_remove((*i).second.write_tag);
    }
}

void add_fd_watch(int fd,int mask,void (*fn)(int , int))
{
    remove_current_watch(fd);

    int rtag=0,wtag=0;
    if ( mask & READ_OK ){
        rtag = gdk_input_add(fd,(GdkInputCondition)GDK_INPUT_READ,
                             fd_event_handler,NULL);
    }

    if ( mask & WRITE_OK ){
        wtag = gdk_input_add(fd,(GdkInputCondition)GDK_INPUT_WRITE,
                             fd_event_handler,NULL);
    }

    fd_watch_struct s;
    s.mask = mask;
    s.fn = fn;
    s.read_tag = rtag;
    s.write_tag = wtag;
    pair<int,fd_watch_struct> p(fd,s);
    fd_watch_stat.insert(p);
    
}

void set_fd_watch_mask(int fd,int mask)
{
    map<int,fd_watch_struct>::iterator i;
    i = fd_watch_stat.find(fd);
    if ( i == fd_watch_stat.end()){
        return ;
    }
    fd_watch_struct s;    
    s = (*i).second;
    if ( s.mask & READ_OK ){
        gdk_input_remove(s.read_tag);
    }
    if ( s.mask & WRITE_OK ){
        gdk_input_remove(s.write_tag);
    }
    fd_watch_stat.erase(i);
    add_fd_watch(fd,mask,s.fn);
}

void remove_fd_watch(int fd)
{
    map<int,fd_watch_struct>::iterator i;
    i = fd_watch_stat.find(fd);
    if ( i != fd_watch_stat.end() ){
        if ( (*i).second.mask & READ_OK){
            gdk_input_remove((*i).second.read_tag);
        }
        if ( (*i).second.mask & WRITE_OK){
            gdk_input_remove((*i).second.write_tag);
        }
        fd_watch_stat.erase(i);
    }
}

void init_fd_watch()
{
    //äȤ˥ޤ򸺤餹(פ󤫡)
}

void add_window_watch(unsigned int id,WindowIf *w,int mask)
{
    pair<unsigned int,WindowIf *> p(id,w);
    window_watch_stat.insert(p);

    //٥ȥޥX.hƤΤƱͤĤ
    //˰¸ץϽ񤫤ʤ
    int emask=0;
    if ( mask & EXPOSE_MASK ){
	emask |= ExposureMask;
    }
    if ( mask & STRUCTURE_NOTIFY_MASK ){
	emask |= StructureNotifyMask;
    }
    XSelectInput(g_dpy,id,emask);
}

void remove_window_watch(unsigned int id)
{
    map<unsigned int,WindowIf *>::iterator i;
    i = window_watch_stat.find(id);
    if ( i != window_watch_stat.end()){
	XSelectInput(g_dpy,id,0);
	window_watch_stat.erase(i);
    }
}

// GtkWidgetΥ٥ȥϥɥ
//
static widget_watch_struct *find_widget_watch(GtkWidget *g)
{
    map<GtkWidget *,widget_watch_struct *>::iterator i;
    i = widget_watch_stat.find(g);
    if ( i != widget_watch_stat.end() ){
	return (*i).second;
    }
    return NULL;
}

static void widget_destroy(GtkWidget *w,gpointer p)
{
    map<GtkWidget *,widget_watch_struct *>::iterator i;
    i = widget_watch_stat.find(w);
    if ( i != widget_watch_stat.end()){
	widget_watch_struct *s;
	s = (*i).second;
	if ( s->mask & WIDGET_DESTROY){
	    s->i->destroy(w);
	}
	free(s);
	widget_watch_stat.erase(i);
    }
}

static gint expose_event(GtkWidget *g,GdkEventExpose *e)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->expose(g);
    }
    return FALSE;
}

static void clicked_event(GtkWidget *g,gpointer p)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->clicked(g);
    }
}

static gint activate_event(GtkWidget *g,gpointer p)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->activate(g,p);
    }
    return TRUE;
}

static void select_row_event(GtkWidget *g,gint row,gint column,GdkEventButton *,gpointer *)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->select_row(g,row,column);
    }
}

static void key_press_event(GtkWidget *g,GdkEventKey *e,gpointer u)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->key_press(g,e);
    }
}

static void resize_event(GtkWidget *g,GdkEventConfigure *event)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->resize(g,g->allocation.width,g->allocation.height);
    }
}

static void button_press_event(GtkWidget *g,GdkEventButton *event)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->button_press(g,(int)event->x,(int)event->y,event->button);
    }
}

static void button_release_event(GtkWidget *g,GdkEventButton *event)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->button_release(g,(int)event->x,(int)event->y,event->button);
    }
}

static void motion_notify_event(GtkWidget *g,GdkEventMotion *event)
{
    widget_watch_struct *w;
    w = find_widget_watch(g);
    if ( w ){
        w->i->motion(g,(int)event->x,(int)event->y,event->state);
    }
}

static gint delete_event(GtkWidget *g,GdkEvent *e,gpointer p)
{
    return FALSE;
}

static char *signal_name(int m)
{
    switch(m){
    case WIDGET_DESTROY:return "destroy";
    case WIDGET_EXPOSE:return "expose_event";
    case WIDGET_BUTTON_PRESS:return "button_press_event";
    case WIDGET_CLICK:return "clicked";
    case WIDGET_ACTIVATE:return "activate";
    case WIDGET_DELETE:return "delete_event";
    case WIDGET_ROW_SELECTED:return "select_row";
    case WIDGET_KEY_PRESS:return "key_press_event";
    case WIDGET_RESIZE:return "configure_event";
    case WIDGET_MOTION:return "motion_notify_event";
    case WIDGET_BUTTON_RELEASE:return "button_release_event";
    }
    printf("unknown signal\n");
    return 0;
}

void add_widget_watch(GtkWidget *g,int mask,WidgetIf *w,void *opt)
{
    widget_watch_struct *s =find_widget_watch(g);
    if ( !s ){
	//Ͽ
	s = (widget_watch_struct *)
	    malloc(sizeof(widget_watch_struct));
	s->w = g;
	s->i = w;
	s->mask = 0;
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_DESTROY),
			   GTK_SIGNAL_FUNC(widget_destroy),opt);
    }
  
    int emask=0;
    s->mask|= mask;
    if ( mask & WIDGET_EXPOSE ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_EXPOSE),
			   GTK_SIGNAL_FUNC(expose_event),opt);
	emask |= GDK_EXPOSURE_MASK;
    }
    if ( mask & WIDGET_CLICK ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_CLICK),
			   GTK_SIGNAL_FUNC(clicked_event),opt);
    }
    if ( mask & WIDGET_ACTIVATE ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_ACTIVATE),
			   GTK_SIGNAL_FUNC(activate_event),opt);
    }
    if ( mask & WIDGET_DELETE ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_DELETE),
			   GTK_SIGNAL_FUNC(delete_event),opt);
    }
    if ( mask & WIDGET_ROW_SELECTED ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_ROW_SELECTED),
			   GTK_SIGNAL_FUNC(select_row_event),opt);
    }
    if ( mask & WIDGET_KEY_PRESS ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_KEY_PRESS),
			   GTK_SIGNAL_FUNC(key_press_event),opt);
    }
    if ( mask & WIDGET_RESIZE ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_RESIZE),
			   GTK_SIGNAL_FUNC(resize_event),opt);
    }
    if ( mask & WIDGET_BUTTON_PRESS ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_BUTTON_PRESS),
			   GTK_SIGNAL_FUNC(button_press_event),opt);
    }
    if ( mask & WIDGET_BUTTON_RELEASE ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_BUTTON_RELEASE),
			   GTK_SIGNAL_FUNC(button_release_event),opt);
    }
    if ( mask & WIDGET_MOTION ){
	gtk_signal_connect(GTK_OBJECT(g),signal_name(WIDGET_MOTION),
			   GTK_SIGNAL_FUNC(motion_notify_event),opt);
    }
    if ( emask ){
	gtk_widget_set_events(g,gtk_widget_get_events(g)|emask);
    }
    pair<GtkWidget *,widget_watch_struct *> p(g,s);
    widget_watch_stat.insert(p);
}

void remove_widget_watch(GtkWidget *w)
{
    map<GtkWidget *,widget_watch_struct *>::iterator i;
  
    i = widget_watch_stat.find(w);
    if ( i != widget_watch_stat.end()){
	// XXX signal_disconnectƤǤʤ
	free((*i).second);
	widget_watch_stat.erase(i);
    }else{
	//դʤä顢destroy줿Ȥơ
	//OK
    }
}
//
void register_atoms()
{
    xim_servers = XInternAtom(g_dpy ,"XIM_SERVERS",0);
    server_heke = XInternAtom(g_dpy ,"@server=jmode",0);
    locales = XInternAtom(g_dpy,"LOCALES",0);
    transport = XInternAtom(g_dpy,"TRANSPORT",0);
}

bool register_prop()
{
    Atom type;
    int format;
    unsigned long nr_prop,nr_bytes;
    Atom *prop;
    XGetWindowProperty(g_dpy,DefaultRootWindow(g_dpy),
                       xim_servers,0,8192,False,
                       XA_ATOM,&type,&format,
                       &nr_prop,&nr_bytes,(unsigned char **)&prop);
    bool bFound = false;
    int i;
    if ( nr_prop > 1){
	//ĤѴФȤꤹ뤿
	nr_prop = 1;
    }
    for ( i = 0 ; i < (int)nr_prop ; i++){
	if ( prop[i] == server_heke ){
	    bFound = true;
	}
    }
    if ( nr_prop ){
	XFree(prop);
    }

    Window selection_owner;
    selection_owner = XGetSelectionOwner(g_dpy,server_heke);
    //ǤˤΥץѥƥϿƤäƤ⡢ѹ뤳Ȥ
    //PropertyNotifyȯ롣
    if (!bFound || selection_owner== None){
	XChangeProperty(g_dpy,DefaultRootWindow(g_dpy),
			xim_servers,XA_ATOM,32,PropModeReplace,
			(unsigned char *)&server_heke,1);
    }
    if ( selection_owner !=None ){
	printf("another instance exist.\n");
	return false;
    }
    return true;
}

bool pretrans_register()
{
    g_dpy = XOpenDisplay(NULL);
    if (!g_dpy ){
        printf("failed to open display!\n");
        return false;
    }
    register_atoms();
    if (!register_prop()){
	XCloseDisplay(g_dpy);
	return false;
    }
    XFlush(g_dpy);
    scr_width = DisplayWidth(g_dpy,0);
    scr_height = DisplayHeight(g_dpy,0);
    return true;
}

void sendSelectionNotify(XEvent *ev,char *buf,int len)
{
    XEvent e;
    e.type = SelectionNotify;
    e.xselection.requestor = ev->xselectionrequest.requestor;
    e.xselection.selection = ev->xselectionrequest.selection;
    e.xselection.target = ev->xselectionrequest.target;
    e.xselection.time = ev->xselectionrequest.time;
    e.xselection.property = ev->xselectionrequest.property;
    XChangeProperty(g_dpy,e.xselection.requestor,
                    e.xselection.property,
                    e.xselection.target,
                    8,PropModeReplace,
                    (unsigned char *)buf,len);
    XSendEvent(g_dpy,e.xselection.requestor,0,0,&e);
    XFlush(g_dpy);
}

void notifyLocale(XEvent *ev)
{
    char buf[32];
    strcpy(buf,"@locale=ja_JP");
    sendSelectionNotify(ev,buf,strlen(buf)+1);
    if ( g_option_mask & OPT_TRACE ){
	printf("selection notify request for locale.\n");
    }
}

void notifyTransport(XEvent *ev)
{
    char buf[90];
    char hostname[64];
    gethostname(hostname,64);
    
    sprintf(buf,"@transport=tcp/%s:%d",hostname,g_serv_port);
    sendSelectionNotify(ev,buf,strlen(buf)+1);
    if ( g_option_mask & OPT_TRACE ){
	printf("selection notify request for transport.\n");
    }
}

WindowIf *findWindowIf(Window w)
{
    map<unsigned int,WindowIf *>::iterator i;
    i = window_watch_stat.find(w);
    if ( i == window_watch_stat.end()){
	return NULL;
    }
    return (*i).second;
}

void WindowIf::resize(Window ,int,int)
{
    // do nothing
}

int X_error_handler(Display *d,XErrorEvent *e)
{
    if ( g_option_mask & OPT_TRACE ){
	printf("X error occured.\n");
    }
    return 0;
}

int X_io_error_handler(Display *d)
{
    global_finalize(0);
    return 0;
}

void ProcXEvent(XEvent *e)
{
    Atom p;
    switch(e->type){
    case SelectionRequest:
    {
	p = e->xselectionrequest.property;
	if( p == locales ){
	    notifyLocale(e);
	}else if( p == transport ){
	    notifyTransport(e);
	}else{
	    printf("property %s?\n",XGetAtomName(g_dpy,e->xselection.property));
	    break;
	}
    }
    break;
    case Expose:
    {
	if ( e->xexpose.count == 0){
	    WindowIf *i = findWindowIf(e->xexpose.window);
	    if ( i ){
		i->expose(e->xexpose.window);
	    }
	}
    }
    break;
    case ConfigureNotify:
    {
	WindowIf *i = findWindowIf(e->xconfigure.window);
	if ( i ){
	    i->resize(e->xconfigure.window,e->xconfigure.x,e->xconfigure.y);
	}
    }
    break;
    case DestroyNotify:
    {
	WindowIf *i = findWindowIf(e->xdestroywindow.window);
	if ( i ){
	    i->destroy(e->xdestroywindow.window);
	}
    }
    break;
    case ClientMessage:
    {
    }
    break;
    }
}

void xevent_read(int fd,int ev)
{
    XFlush(g_dpy);

    XEvent e;
    while(XPending(g_dpy)){
	XNextEvent(g_dpy,&e);
	ProcXEvent(&e);
    }
}

int pretrans_setup()
{
    int fd;
  
    XSetErrorHandler(X_error_handler);
    XSetIOErrorHandler(X_io_error_handler);
    wnd = XCreateSimpleWindow(g_dpy,DefaultRootWindow(g_dpy),
                              0,0,1,1,1,0,0);

    XSetSelectionOwner(g_dpy,server_heke,wnd,CurrentTime);
    XSelectInput(g_dpy,DefaultRootWindow(g_dpy),0);

    XSync(g_dpy,False);

    fd = XConnectionNumber(g_dpy);
    add_fd_watch(fd,READ_OK,xevent_read);

    return fd;
}

void ctrl_event(int fd,int ev)
{
    if ( ev & READ_OK ){
	char buf[256];
	fgets(buf,256,ctrl_in);
	if ( !strncmp(buf,"UI ",3)){
	    ui_ctrl_command(&buf[3]);
	}else if (!strncmp(buf,"KK ",3)){
	    kk_ctrl_command(&buf[3]);			
	}
    }
}

void init_ctrl()
{
    ctrl_in = fdopen(ctrl_fd_r,"r");
    ctrl_out = fdopen(ctrl_fd_w,"w");
    if ( !ctrl_in || !ctrl_out ){
	printf("failed to setup controller.\n");
	g_option_mask |= ~OPT_CTRL;
	return ;
    }
    add_fd_watch(ctrl_fd_r,READ_OK,ctrl_event);
}
/*
 * Local variables:
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 */
